<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-pragma">{-# LANGUAGE TemplateHaskell #-}</span><span>
</span><a name="line-2"></a><span>
</span><a name="line-3"></a><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Internal</span><span> </span><span class="hs-keyword">where</span><span>
</span><a name="line-4"></a><span>
</span><a name="line-5"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Control</span><span class="hs-operator">.</span><span class="hs-identifier">Concurrent</span><span>
</span><a name="line-6"></a><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="hs-identifier">Data</span><span class="hs-operator">.</span><span class="hs-identifier">ByteString</span><span class="hs-operator">.</span><span class="hs-identifier">Lazy</span><span>    </span><span class="hs-keyword">as</span><span> </span><span class="hs-identifier">BL</span><span>
</span><a name="line-7"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Data</span><span class="hs-operator">.</span><span class="hs-identifier">Function</span><span>           </span><span class="hs-special">(</span><span class="hs-identifier hs-var">on</span><span class="hs-special">)</span><span>
</span><a name="line-8"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Data</span><span class="hs-operator">.</span><span class="hs-identifier">Global</span><span>
</span><a name="line-9"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Data</span><span class="hs-operator">.</span><span class="hs-identifier">IORef</span><span>              </span><span class="hs-special">(</span><span class="hs-identifier hs-var">readIORef</span><span class="hs-special">,</span><span> </span><span class="hs-identifier hs-var">writeIORef</span><span class="hs-special">)</span><span>
</span><a name="line-10"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Data</span><span class="hs-operator">.</span><span class="hs-identifier">List</span><span>               </span><span class="hs-keyword">as</span><span> </span><span class="hs-identifier">L</span><span>
</span><a name="line-11"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Data</span><span class="hs-operator">.</span><span class="hs-identifier">Maybe</span><span>              </span><span class="hs-keyword">as</span><span> </span><span class="hs-identifier">M</span><span>
</span><a name="line-12"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Data</span><span class="hs-operator">.</span><span class="hs-identifier">String</span><span>
</span><a name="line-13"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Data</span><span class="hs-operator">.</span><span class="hs-identifier">Text</span><span>               </span><span class="hs-keyword">as</span><span> </span><span class="hs-identifier">T</span><span>
</span><a name="line-14"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Data</span><span class="hs-operator">.</span><span class="hs-identifier">Text</span><span class="hs-operator">.</span><span class="hs-identifier">Conversions</span><span>   </span><span class="hs-special">(</span><span class="hs-identifier hs-var">convertText</span><span class="hs-special">)</span><span>
</span><a name="line-15"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Data</span><span class="hs-operator">.</span><span class="hs-identifier">Time</span><span class="hs-operator">.</span><span class="hs-identifier">Clock</span><span>
</span><a name="line-16"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Protolude</span><span>
</span><a name="line-17"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">System</span><span class="hs-operator">.</span><span class="hs-identifier">Environment</span><span>
</span><a name="line-18"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Text</span><span class="hs-operator">.</span><span class="hs-identifier">Read</span><span>               </span><span class="hs-special">(</span><span class="hs-identifier hs-var">read</span><span class="hs-special">)</span><span>
</span><a name="line-19"></a><span>
</span><a name="line-20"></a><span class="hs-comment">-- aeson</span><span>
</span><a name="line-21"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Data</span><span class="hs-operator">.</span><span class="hs-identifier">Aeson</span><span>
</span><a name="line-22"></a><span>
</span><a name="line-23"></a><span class="hs-comment">-- http</span><span>
</span><a name="line-24"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Network</span><span class="hs-operator">.</span><span class="hs-identifier">HTTP</span><span class="hs-operator">.</span><span class="hs-identifier">Client</span><span>     </span><span class="hs-special">(</span><span class="hs-identifier hs-var">newManager</span><span class="hs-special">)</span><span>
</span><a name="line-25"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Network</span><span class="hs-operator">.</span><span class="hs-identifier">HTTP</span><span class="hs-operator">.</span><span class="hs-identifier">Client</span><span class="hs-operator">.</span><span class="hs-identifier">TLS</span><span> </span><span class="hs-special">(</span><span class="hs-identifier hs-var">tlsManagerSettings</span><span class="hs-special">)</span><span>
</span><a name="line-26"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Network</span><span class="hs-operator">.</span><span class="hs-identifier">HTTP</span><span class="hs-operator">.</span><span class="hs-identifier">Conduit</span><span>
</span><a name="line-27"></a><span>
</span><a name="line-28"></a><span class="hs-comment">-- telegram-api</span><span>
</span><a name="line-29"></a><span class="hs-keyword">import</span><span>           </span><span class="hs-identifier">Web</span><span class="hs-operator">.</span><span class="hs-identifier">Telegram</span><span class="hs-operator">.</span><span class="hs-identifier">API</span><span class="hs-operator">.</span><span class="hs-identifier">Bot</span><span>
</span><a name="line-30"></a><span>
</span><a name="line-31"></a><span class="hs-comment">-- internal library</span><span>
</span><a name="line-32"></a><span class="hs-keyword">import</span><span>           </span><a href="Types.html"><span class="hs-identifier">Types</span></a><span>
</span><a name="line-33"></a><span>
</span><a name="line-34"></a><span class="hs-comment">-- prepare lastEventId as global variable</span><span>
</span><a name="line-35"></a><span class="hs-identifier hs-var">declareIORef</span><span> </span><span class="hs-string">&quot;lastEventId&quot;</span><span> </span><span class="hs-special">[</span><span class="hs-identifier hs-var">t</span><span class="hs-glyph">|</span><span class="hs-identifier hs-var">Int</span><span class="hs-glyph">|</span><span class="hs-special">]</span><span> </span><span class="hs-special">[</span><span class="hs-glyph">|</span><span class="hs-number">0</span><span class="hs-glyph">|</span><span class="hs-special">]</span><span>
</span><a name="line-36"></a><span>
</span><a name="line-37"></a><span class="hs-comment">-- | Start World Cup 2018 Bot.</span><span>
</span><a name="line-38"></a><span class="hs-identifier">startBot</span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-identifier hs-type">IO</span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><a name="line-39"></a><a name="startBot"><a href="Internal.html#startBot"><span class="hs-identifier">startBot</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-identifier hs-var">forever</span><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-keyword">do</span><span>
</span><a name="line-40"></a><span>  </span><span class="hs-comment">-- get start time</span><span>
</span><a name="line-41"></a><span>  </span><a name="local-6989586621679194465"><a href="#local-6989586621679194465"><span class="hs-identifier">start</span></a></a><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="hs-identifier hs-var">getCurrentTime</span><span>
</span><a name="line-42"></a><span>
</span><a name="line-43"></a><span>  </span><a name="local-6989586621679194466"><a href="#local-6989586621679194466"><span class="hs-identifier">matchURL</span></a></a><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="hs-identifier hs-var">getEnv</span><span> </span><span class="hs-string">&quot;MATCH_CURRENT_URL&quot;</span><span>
</span><a name="line-44"></a><span>  </span><a name="local-6989586621679194467"><a href="#local-6989586621679194467"><span class="hs-identifier">matchResponse</span></a></a><span> </span><span class="hs-glyph">&lt;-</span><span> </span><a href="Internal.html#lookupTodayMatch"><span class="hs-identifier hs-var">lookupTodayMatch</span></a><span> </span><a href="#local-6989586621679194466"><span class="hs-identifier hs-var">matchURL</span></a><span>
</span><a name="line-45"></a><span>  </span><span class="hs-keyword">let</span><span> </span><a name="local-6989586621679194468"><a href="#local-6989586621679194468"><span class="hs-identifier">decodedMatch</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-identifier hs-var">eitherDecode</span><span> </span><a href="#local-6989586621679194467"><span class="hs-identifier hs-var">matchResponse</span></a><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-identifier hs-type">Either</span><span> </span><span class="hs-identifier hs-type">String</span><span> </span><span class="hs-special">[</span><a href="Types.html#Match"><span class="hs-identifier hs-type">Match</span></a><span class="hs-special">]</span><span>
</span><a name="line-46"></a><span>  </span><span class="hs-keyword">case</span><span> </span><a href="#local-6989586621679194468"><span class="hs-identifier hs-var">decodedMatch</span></a><span> </span><span class="hs-keyword">of</span><span>
</span><a name="line-47"></a><span>    </span><span class="hs-identifier hs-var">Left</span><span> </span><a name="local-6989586621679194469"><a href="#local-6989586621679194469"><span class="hs-identifier">err</span></a></a><span>      </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-identifier hs-var">putStrLn</span><span> </span><a href="#local-6989586621679194469"><span class="hs-identifier hs-var">err</span></a><span>
</span><a name="line-48"></a><span>    </span><span class="hs-identifier hs-var">Right</span><span> </span><a name="local-6989586621679194589"><a href="#local-6989586621679194589"><span class="hs-identifier">matches</span></a></a><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><a name="line-49"></a><span>      </span><span class="hs-identifier hs-var">mapM_</span><span> </span><a href="Internal.html#processMatch"><span class="hs-identifier hs-var">processMatch</span></a><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-identifier hs-var">L</span><span class="hs-operator hs-var">.</span><span class="hs-identifier hs-var">filter</span><span> </span><span class="hs-special">(</span><span class="hs-glyph">\</span><a name="local-6989586621679195690"><a href="#local-6989586621679195690"><span class="hs-identifier">x</span></a></a><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-identifier">matchStatus</span><span> </span><a href="#local-6989586621679195690"><span class="hs-identifier hs-var">x</span></a><span> </span><span class="hs-operator hs-var">==</span><span> </span><span class="hs-string">&quot;in progress&quot;</span><span class="hs-special">)</span><span> </span><a href="#local-6989586621679194589"><span class="hs-identifier hs-var">matches</span></a><span>
</span><a name="line-50"></a><span>      </span><span class="hs-identifier hs-var">putStrLn</span><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-identifier hs-var">show</span><span> </span><span class="hs-special">(</span><span class="hs-identifier hs-var">L</span><span class="hs-operator hs-var">.</span><span class="hs-identifier hs-var">length</span><span> </span><a href="#local-6989586621679194589"><span class="hs-identifier hs-var">matches</span></a><span class="hs-special">)</span><span> </span><span class="hs-operator hs-var">++</span><span> </span><span class="hs-string">&quot; matches processed&quot;</span><span>
</span><a name="line-51"></a><span>
</span><a name="line-52"></a><span>  </span><span class="hs-comment">-- get end time and calculate delay</span><span>
</span><a name="line-53"></a><span>  </span><a name="local-6989586621679195691"><a href="#local-6989586621679195691"><span class="hs-identifier">end</span></a></a><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="hs-identifier hs-var">getCurrentTime</span><span>
</span><a name="line-54"></a><span>  </span><span class="hs-keyword">let</span><span> </span><a name="local-6989586621679195692"><a href="#local-6989586621679195692"><span class="hs-identifier">diff</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-identifier hs-var">diffUTCTime</span><span> </span><a href="#local-6989586621679195691"><span class="hs-identifier hs-var">end</span></a><span> </span><a href="#local-6989586621679194465"><span class="hs-identifier hs-var">start</span></a><span>
</span><a name="line-55"></a><span>      </span><a name="local-6989586621679195693"><a href="#local-6989586621679195693"><span class="hs-identifier">usecs</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-identifier hs-var">floor</span><span> </span><span class="hs-special">(</span><span class="hs-identifier hs-var">toRational</span><span> </span><a href="#local-6989586621679195692"><span class="hs-identifier hs-var">diff</span></a><span> </span><span class="hs-operator hs-var">*</span><span> </span><span class="hs-number">1000000</span><span class="hs-special">)</span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-identifier hs-type">Int</span><span>
</span><a name="line-56"></a><span>      </span><a name="local-6989586621679195694"><a href="#local-6989586621679195694"><span class="hs-identifier">delay</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-number">10000</span><span class="hs-operator hs-var">*</span><span class="hs-number">1000</span><span> </span><span class="hs-glyph">-</span><span> </span><a href="#local-6989586621679195693"><span class="hs-identifier hs-var">usecs</span></a><span>
</span><a name="line-57"></a><span>  </span><span class="hs-keyword">if</span><span> </span><a href="#local-6989586621679195694"><span class="hs-identifier hs-var">delay</span></a><span> </span><span class="hs-operator hs-var">&gt;</span><span> </span><span class="hs-number">0</span><span>
</span><a name="line-58"></a><span>    </span><span class="hs-keyword">then</span><span> </span><span class="hs-identifier hs-var">threadDelay</span><span> </span><a href="#local-6989586621679195694"><span class="hs-identifier hs-var">delay</span></a><span>
</span><a name="line-59"></a><span>    </span><span class="hs-keyword">else</span><span> </span><span class="hs-identifier hs-var">return</span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><a name="line-60"></a><span>
</span><a name="line-61"></a><span class="hs-comment">-- | Lookup today's `Match`.</span><span>
</span><a name="line-62"></a><span class="hs-identifier">lookupTodayMatch</span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-identifier hs-type">String</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-identifier hs-type">IO</span><span> </span><span class="hs-identifier hs-type">BL</span><span class="hs-operator hs-type">.</span><span class="hs-identifier hs-type">ByteString</span><span>
</span><a name="line-63"></a><a name="lookupTodayMatch"><a href="Internal.html#lookupTodayMatch"><span class="hs-identifier">lookupTodayMatch</span></a></a><span> </span><a name="local-6989586621679195748"><a href="#local-6989586621679195748"><span class="hs-identifier">url</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-identifier hs-var">simpleHttp</span><span> </span><a href="#local-6989586621679195748"><span class="hs-identifier hs-var">url</span></a><span>
</span><a name="line-64"></a><span>
</span><a name="line-65"></a><span class="hs-comment">-- | Process `Match`.</span><span>
</span><a name="line-66"></a><span class="hs-identifier">processMatch</span><span> </span><span class="hs-glyph">::</span><span> </span><a href="Types.html#Match"><span class="hs-identifier hs-type">Match</span></a><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-identifier hs-type">IO</span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><a name="line-67"></a><a name="processMatch"><a href="Internal.html#processMatch"><span class="hs-identifier">processMatch</span></a></a><span> </span><a name="local-6989586621679195749"><a href="#local-6989586621679195749"><span class="hs-identifier">m</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-identifier hs-var">mapM_</span><span> </span><span class="hs-special">(</span><a href="Internal.html#processEvent"><span class="hs-identifier hs-var">processEvent</span></a><span> </span><a href="#local-6989586621679195749"><span class="hs-identifier hs-var">m</span></a><span class="hs-special">)</span><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-identifier hs-var">sortBy</span><span> </span><span class="hs-special">(</span><span class="hs-identifier hs-var">on</span><span> </span><span class="hs-identifier hs-var">compare</span><span> </span><span class="hs-identifier">eventId</span><span class="hs-special">)</span><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-identifier">matchHomeTeamEvents</span><span> </span><a href="#local-6989586621679195749"><span class="hs-identifier hs-var">m</span></a><span> </span><span class="hs-operator hs-var">++</span><span> </span><span class="hs-identifier">matchAwayTeamEvents</span><span> </span><a href="#local-6989586621679195749"><span class="hs-identifier hs-var">m</span></a><span>
</span><a name="line-68"></a><span>
</span><a name="line-69"></a><span class="hs-comment">-- | Process `Event`.</span><span>
</span><a name="line-70"></a><span class="hs-identifier">processEvent</span><span> </span><span class="hs-glyph">::</span><span> </span><a href="Types.html#Match"><span class="hs-identifier hs-type">Match</span></a><span> </span><span class="hs-glyph">-&gt;</span><span> </span><a href="Types.html#Event"><span class="hs-identifier hs-type">Event</span></a><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-identifier hs-type">IO</span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><a name="line-71"></a><a name="processEvent"><a href="Internal.html#processEvent"><span class="hs-identifier">processEvent</span></a></a><span> </span><a name="local-6989586621679195891"><a href="#local-6989586621679195891"><span class="hs-identifier">match</span></a></a><span> </span><a name="local-6989586621679195892"><a href="#local-6989586621679195892"><span class="hs-identifier">event</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">do</span><span>
</span><a name="line-72"></a><span>  </span><a name="local-6989586621679195931"><a href="#local-6989586621679195931"><span class="hs-identifier">eid</span></a></a><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="hs-identifier hs-var">readIORef</span><span> </span><a href="Internal.html#lastEventId"><span class="hs-identifier hs-var">lastEventId</span></a><span>
</span><a name="line-73"></a><span>  </span><span class="hs-keyword">if</span><span> </span><span class="hs-identifier">eventId</span><span> </span><a href="#local-6989586621679195892"><span class="hs-identifier hs-var">event</span></a><span> </span><span class="hs-operator hs-var">&gt;</span><span> </span><a href="#local-6989586621679195931"><span class="hs-identifier hs-var">eid</span></a><span>
</span><a name="line-74"></a><span>    </span><span class="hs-keyword">then</span><span> </span><span class="hs-keyword">do</span><span>
</span><a name="line-75"></a><span>      </span><a href="Internal.html#sendEvent"><span class="hs-identifier hs-var">sendEvent</span></a><span> </span><a href="#local-6989586621679195891"><span class="hs-identifier hs-var">match</span></a><span> </span><a href="#local-6989586621679195892"><span class="hs-identifier hs-var">event</span></a><span>
</span><a name="line-76"></a><span>      </span><a href="Internal.html#updateLastEventId"><span class="hs-identifier hs-var">updateLastEventId</span></a><span> </span><a href="#local-6989586621679195892"><span class="hs-identifier hs-var">event</span></a><span>
</span><a name="line-77"></a><span>    </span><span class="hs-keyword">else</span><span> </span><span class="hs-identifier hs-var">return</span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><a name="line-78"></a><span>
</span><a name="line-79"></a><span class="hs-comment">-- | Update `lastEventId`.</span><span>
</span><a name="line-80"></a><span class="hs-identifier">updateLastEventId</span><span> </span><span class="hs-glyph">::</span><span> </span><a href="Types.html#Event"><span class="hs-identifier hs-type">Event</span></a><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-identifier hs-type">IO</span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><a name="line-81"></a><a name="updateLastEventId"><a href="Internal.html#updateLastEventId"><span class="hs-identifier">updateLastEventId</span></a></a><span> </span><a name="local-6989586621679195932"><a href="#local-6989586621679195932"><span class="hs-identifier">event</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-identifier hs-var">writeIORef</span><span> </span><a href="Internal.html#lastEventId"><span class="hs-identifier hs-var">lastEventId</span></a><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-identifier">eventId</span><span> </span><a href="#local-6989586621679195932"><span class="hs-identifier hs-var">event</span></a><span>
</span><a name="line-82"></a><span>
</span><a name="line-83"></a><span class="hs-comment">-- | Send `Event` to telegram.</span><span>
</span><a name="line-84"></a><span class="hs-identifier">sendEvent</span><span> </span><span class="hs-glyph">::</span><span> </span><a href="Types.html#Match"><span class="hs-identifier hs-type">Match</span></a><span> </span><span class="hs-glyph">-&gt;</span><span> </span><a href="Types.html#Event"><span class="hs-identifier hs-type">Event</span></a><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-identifier hs-type">IO</span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><a name="line-85"></a><a name="sendEvent"><a href="Internal.html#sendEvent"><span class="hs-identifier">sendEvent</span></a></a><span> </span><a name="local-6989586621679195933"><a href="#local-6989586621679195933"><span class="hs-identifier">match</span></a></a><span> </span><a name="local-6989586621679195934"><a href="#local-6989586621679195934"><span class="hs-identifier">event</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">do</span><span>
</span><a name="line-86"></a><span>  </span><a name="local-6989586621679195935"><a href="#local-6989586621679195935"><span class="hs-identifier">token</span></a></a><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="hs-identifier hs-var">getEnv</span><span> </span><span class="hs-string">&quot;TELEGRAM_TOKEN&quot;</span><span>
</span><a name="line-87"></a><span>  </span><a name="local-6989586621679195936"><a href="#local-6989586621679195936"><span class="hs-identifier">chatId</span></a></a><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="hs-identifier hs-var">getEnv</span><span> </span><span class="hs-string">&quot;TELEGRAM_CHAT_ID&quot;</span><span>
</span><a name="line-88"></a><span>
</span><a name="line-89"></a><span>  </span><span class="hs-comment">-- Prepare token and chatId</span><span>
</span><a name="line-90"></a><span>  </span><span class="hs-keyword">let</span><span> </span><a name="local-6989586621679195937"><a href="#local-6989586621679195937"><span class="hs-identifier">token'</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-identifier hs-var">Token</span><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-identifier hs-var">convertText</span><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-string">&quot;bot&quot;</span><span> </span><span class="hs-operator hs-var">++</span><span> </span><a href="#local-6989586621679195935"><span class="hs-identifier hs-var">token</span></a><span>
</span><a name="line-91"></a><span>      </span><a name="local-6989586621679195938"><a href="#local-6989586621679195938"><span class="hs-identifier">chatId'</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-identifier hs-var">ChatId</span><span> </span><span class="hs-special">(</span><span class="hs-identifier hs-var">read</span><span> </span><a href="#local-6989586621679195936"><span class="hs-identifier hs-var">chatId</span></a><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-identifier hs-type">Int64</span><span class="hs-special">)</span><span>
</span><a name="line-92"></a><span>
</span><a name="line-93"></a><span>  </span><span class="hs-comment">-- Prepare message request</span><span>
</span><a name="line-94"></a><span>  </span><span class="hs-keyword">let</span><span> </span><a name="local-6989586621679196021"><a href="#local-6989586621679196021"><span class="hs-identifier">newEvent</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-string">&quot;*New Event: &quot;</span><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-identifier">eventTypeOfEvent</span><span> </span><a href="#local-6989586621679195934"><span class="hs-identifier hs-var">event</span></a><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-string">&quot;*&quot;</span><span>
</span><a name="line-95"></a><span>      </span><a name="local-6989586621679196022"><a href="#local-6989586621679196022"><span class="hs-identifier">player</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-string">&quot;Player: &quot;</span><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-identifier">eventPlayer</span><span> </span><a href="#local-6989586621679195934"><span class="hs-identifier hs-var">event</span></a><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-string">&quot; (&quot;</span><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-identifier">teamCountry</span><span> </span><span class="hs-special">(</span><span class="hs-identifier">matchHomeTeam</span><span> </span><a href="#local-6989586621679195933"><span class="hs-identifier hs-var">match</span></a><span class="hs-special">)</span><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-string">&quot;)&quot;</span><span>
</span><a name="line-96"></a><span>      </span><a name="local-6989586621679196023"><a href="#local-6989586621679196023"><span class="hs-identifier">at</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-string">&quot;Occurs at: &quot;</span><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-identifier">eventTime</span><span> </span><a href="#local-6989586621679195934"><span class="hs-identifier hs-var">event</span></a><span>
</span><a name="line-97"></a><span>      </span><a name="local-6989586621679196024"><a href="#local-6989586621679196024"><span class="hs-identifier">summary</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-identifier">teamCountry</span><span> </span><span class="hs-special">(</span><span class="hs-identifier">matchHomeTeam</span><span> </span><a href="#local-6989586621679195933"><span class="hs-identifier hs-var">match</span></a><span class="hs-special">)</span><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-string">&quot; (&quot;</span><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-special">(</span><span class="hs-identifier hs-var">show</span><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-identifier">teamGoals</span><span> </span><span class="hs-special">(</span><span class="hs-identifier">matchHomeTeam</span><span> </span><a href="#local-6989586621679195933"><span class="hs-identifier hs-var">match</span></a><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-string">&quot;)&quot;</span><span>
</span><a name="line-98"></a><span>             </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-string">&quot; - &quot;</span><span>
</span><a name="line-99"></a><span>             </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-identifier">teamCountry</span><span> </span><span class="hs-special">(</span><span class="hs-identifier">matchAwayTeam</span><span> </span><a href="#local-6989586621679195933"><span class="hs-identifier hs-var">match</span></a><span class="hs-special">)</span><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-string">&quot; (&quot;</span><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-special">(</span><span class="hs-identifier hs-var">show</span><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-identifier">teamGoals</span><span> </span><span class="hs-special">(</span><span class="hs-identifier">matchAwayTeam</span><span> </span><a href="#local-6989586621679195933"><span class="hs-identifier hs-var">match</span></a><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="hs-operator hs-var">&lt;&gt;</span><span> </span><span class="hs-string">&quot;)&quot;</span><span>
</span><a name="line-100"></a><span>      </span><a name="local-6989586621679196025"><a href="#local-6989586621679196025"><span class="hs-identifier">messages</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">[</span><span> </span><a href="#local-6989586621679196021"><span class="hs-identifier hs-var">newEvent</span></a><span>
</span><a name="line-101"></a><span>                 </span><span class="hs-special">,</span><span> </span><a href="#local-6989586621679196022"><span class="hs-identifier hs-var">player</span></a><span>
</span><a name="line-102"></a><span>                 </span><span class="hs-special">,</span><span> </span><a href="#local-6989586621679196023"><span class="hs-identifier hs-var">at</span></a><span>
</span><a name="line-103"></a><span>                 </span><span class="hs-special">,</span><span> </span><span class="hs-string">&quot;-&quot;</span><span>
</span><a name="line-104"></a><span>                 </span><span class="hs-special">,</span><span> </span><a href="#local-6989586621679196024"><span class="hs-identifier hs-var">summary</span></a><span>
</span><a name="line-105"></a><span>                 </span><span class="hs-special">]</span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">[</span><span class="hs-identifier hs-type">Text</span><span class="hs-special">]</span><span>
</span><a name="line-106"></a><span>      </span><a name="local-6989586621679196026"><a href="#local-6989586621679196026"><span class="hs-identifier">message</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-identifier hs-var">T</span><span class="hs-operator hs-var">.</span><span class="hs-identifier hs-var">unlines</span><span> </span><a href="#local-6989586621679196025"><span class="hs-identifier hs-var">messages</span></a><span>
</span><a name="line-107"></a><span>      </span><a name="local-6989586621679196027"><a href="#local-6989586621679196027"><span class="hs-identifier">request</span></a></a><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-identifier hs-var">SendMessageRequest</span><span>
</span><a name="line-108"></a><span>                  </span><a href="#local-6989586621679195938"><span class="hs-identifier hs-var">chatId'</span></a><span>
</span><a name="line-109"></a><span>                  </span><a href="#local-6989586621679196026"><span class="hs-identifier hs-var">message</span></a><span>
</span><a name="line-110"></a><span>                  </span><span class="hs-special">(</span><span class="hs-identifier hs-var">Just</span><span> </span><span class="hs-identifier hs-var">Markdown</span><span class="hs-special">)</span><span>
</span><a name="line-111"></a><span>                  </span><span class="hs-identifier hs-var">Nothing</span><span>
</span><a name="line-112"></a><span>                  </span><span class="hs-identifier hs-var">Nothing</span><span>
</span><a name="line-113"></a><span>                  </span><span class="hs-identifier hs-var">Nothing</span><span>
</span><a name="line-114"></a><span>                  </span><span class="hs-identifier hs-var">Nothing</span><span>
</span><a name="line-115"></a><span>
</span><a name="line-116"></a><span>  </span><span class="hs-comment">-- Send message request</span><span>
</span><a name="line-117"></a><span>  </span><a name="local-6989586621679196126"><a href="#local-6989586621679196126"><span class="hs-identifier">manager</span></a></a><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="hs-identifier hs-var">newManager</span><span> </span><span class="hs-identifier hs-var">tlsManagerSettings</span><span>
</span><a name="line-118"></a><span>  </span><a name="local-6989586621679196462"><a href="#local-6989586621679196462"><span class="hs-identifier">response</span></a></a><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="hs-identifier hs-var">sendMessage</span><span> </span><a href="#local-6989586621679195937"><span class="hs-identifier hs-var">token'</span></a><span> </span><a href="#local-6989586621679196027"><span class="hs-identifier hs-var">request</span></a><span> </span><a href="#local-6989586621679196126"><span class="hs-identifier hs-var">manager</span></a><span>
</span><a name="line-119"></a><span>  </span><span class="hs-keyword">case</span><span> </span><a href="#local-6989586621679196462"><span class="hs-identifier hs-var">response</span></a><span> </span><span class="hs-keyword">of</span><span>
</span><a name="line-120"></a><span>    </span><span class="hs-identifier hs-var">Left</span><span> </span><a name="local-6989586621679196463"><a href="#local-6989586621679196463"><span class="hs-identifier">err</span></a></a><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-identifier hs-var">print</span><span> </span><a href="#local-6989586621679196463"><span class="hs-identifier hs-var">err</span></a><span>
</span><a name="line-121"></a><span>    </span><span class="hs-identifier hs-var">Right</span><span> </span><a name="local-6989586621679196464"><a href="#local-6989586621679196464"><span class="hs-identifier">res</span></a></a><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-identifier hs-var">putStrLn</span><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-identifier hs-var">M</span><span class="hs-operator hs-var">.</span><span class="hs-identifier hs-var">fromJust</span><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-identifier">text</span><span> </span><span class="hs-operator hs-var">$</span><span> </span><span class="hs-identifier">result</span><span> </span><a href="#local-6989586621679196464"><span class="hs-identifier hs-var">res</span></a><span>
</span><a name="line-122"></a></pre></body></html>